#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define OLED_RESET 4
Adafruit_SSD1306 display(OLED_RESET);


const int lifeLamp = 11;
const int lifeUp = 5;
const int maxLife = 50;
#define NUMFLAKES 10
#define XPOS 0
#define YPOS 1
#define DELTAY 2
double count=0;

// this is the Width and Height of Display which is 128 xy 32 
#define LOGO16_GLCD_HEIGHT 32
#define LOGO16_GLCD_WIDTH  128 

const int lamp1 = 3;
const int lamp2 = 5;
const int lamp3 = 7;
const int lamp4 = 9;
const int lamp5 = 10;
const int button = 8;
const int slide = A1;

int slider;
int buttonPress;
int light;
int life;
int bright;
int start;
int score;
int spam;


void setup() {
  // put your setup code here, to run once:
  pinMode( lamp1, OUTPUT);
  pinMode( lamp2, OUTPUT);
  pinMode( lamp3, OUTPUT);
  pinMode( lamp4, OUTPUT);
  pinMode( lamp5, OUTPUT);
  pinMode( lifeLamp, OUTPUT);
  pinMode( button, INPUT);
  pinMode( slide, INPUT);
  light = random(1,6);
  slider= analogRead (slide);
  buttonPress= digitalRead(button);
  Serial.begin(9600);

  // by default, we'll generate the high voltage from the 3.3v line internally! (neat!)
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);  // initialize with the I2C addr 0x3C (for the 128x32)
  display.display();
  delay(2000);
   // Clear the buffer.
  display.clearDisplay(); 
  score = 0;
  start = 0;
  life = maxLife;
  spam = 0;
}

void robojaxText(String text, int x, int y,int size, boolean d) {

  display.setTextSize(size);
  display.setTextColor(WHITE);
  display.setCursor(x,y);
  display.println(text);
  if(d){
    display.display();
  }
  
  //delay(100);
 }

void loop() {
  // put your main code here, to run repeatedly:
 if (start == 0) {
  buttonPress= digitalRead(button);
  display.clearDisplay();
  robojaxText("HOLD", 4, 11, 2, false);
  display.display();
  digitalWrite(lamp1,LOW);
  digitalWrite(lamp2,LOW);
  digitalWrite(lamp3,LOW);
  digitalWrite(lamp4,LOW);
  digitalWrite(lamp5,LOW);
  digitalWrite(lifeLamp,LOW);
  delay(100);
  digitalWrite(lamp1,HIGH);
  digitalWrite(lamp5,HIGH);
  delay(100);
  digitalWrite(lamp2,HIGH);
  digitalWrite(lamp4,HIGH);
  delay(100);
  digitalWrite(lamp3,HIGH);
  digitalWrite(lifeLamp,HIGH);
  delay(500);
  display.clearDisplay();
  robojaxText("BUTTON", 4, 11, 2, false);
  display.display();
  delay(1000);
  if (buttonPress == 1) {
    start = 1;
    life = maxLife;
    spam = 0;
    score = 0;
  }
 }
 else if (start == 1){
  slider= analogRead (slide);
  buttonPress= digitalRead(button);

   noInterrupts();
     life --;
     delay(100);
  
  interrupts();
  
  
  
  if (light == 1) {
    digitalWrite ( lamp1, HIGH);
    digitalWrite ( lamp2, LOW);
    digitalWrite ( lamp3, LOW);
    digitalWrite ( lamp4, LOW);
    digitalWrite ( lamp5, LOW);
    }
  
  else if (light == 2) {
    digitalWrite ( lamp1, LOW);
    digitalWrite ( lamp2, HIGH);
    digitalWrite ( lamp3, LOW);
    digitalWrite ( lamp4, LOW);
    digitalWrite ( lamp5, LOW); 
  }

    else if (light == 3) {
    digitalWrite ( lamp1, LOW);
    digitalWrite ( lamp2, LOW);
    digitalWrite ( lamp3, HIGH);
    digitalWrite ( lamp4, LOW);
    digitalWrite ( lamp5, LOW); 
  }

  else if (light == 4) {
    digitalWrite ( lamp1, LOW);
    digitalWrite ( lamp2, LOW);
    digitalWrite ( lamp3, LOW);
    digitalWrite ( lamp4, HIGH);
    digitalWrite ( lamp5, LOW);
  }
    else if (light == 5) {
    digitalWrite ( lamp1, LOW);
    digitalWrite ( lamp2, LOW);
    digitalWrite ( lamp3, LOW);
    digitalWrite ( lamp4, LOW);
    digitalWrite ( lamp5, HIGH);
  }

  if (light == 1 && slider >= 0 && slider < 206 && buttonPress == 1 && spam == 0) {
    light = random(1,6);
    life = life+ lifeUp;
    score = score+ 1;
    spam = 1;
  }
  
  if (light == 2 && slider > 205 && slider < 411 && buttonPress == 1 && spam == 0) {
    light = random(1,6);
    life = life+ lifeUp; 
    score = score+ 1;
    spam = 1;
  }

   if (light == 3 && slider > 410 && slider < 616 && buttonPress == 1 && spam == 0) {
    light = random(1,6);
    life = life+ lifeUp; 
    score = score+ 1;  
    spam = 1;
  }
  

   if (light == 4 && slider > 615 && slider < 821 && buttonPress == 1 && spam == 0) {
    light = random(1,6);
    life = life+ lifeUp; 
    score = score+ 1;
    spam = 1;
  }
  
   if (light == 5 && slider > 820 && slider < 1024 && buttonPress == 1 && spam == 0) {
    light = random(1,6);
    life = life+ lifeUp;
     score = score+ 1; 
     spam = 1;
  }
   if (buttonPress == 0){
    spam = 0;
   }
  
  
  bright = map(life, 0, maxLife, 0, 100);

  analogWrite(lifeLamp, bright);
    String scoreString =  String(score);// using a float and the 
  display.clearDisplay();
  robojaxText(scoreString, 75, 11, 2, false);
  robojaxText("SCORE:", 4, 11, 2, false);
 
  //display.drawLine(1, 37, 100, 37, WHITE);
 //display.drawRect(1, 1, 126,31, WHITE);
  //display.drawCircle(63,31, 31, WHITE);
   //display.startscrollright(0x00, 0x0F);
  display.display();
   Serial.println(slider);
   if (life <= 0){
    start = 2;
   }
  }
  
  else if (start == 2){
    buttonPress= digitalRead(button);
    display.clearDisplay();
    String scoreString =  String(score);
    robojaxText(scoreString, 40, 11, 2, false);
    display.display();
    
    digitalWrite(lamp1,HIGH);
    digitalWrite(lamp2,HIGH);
    digitalWrite(lamp3,HIGH);
    digitalWrite(lamp4,HIGH);
    digitalWrite(lamp5,HIGH);
    delay(500);
    digitalWrite(lamp1,LOW);
    digitalWrite(lamp2,LOW);
    digitalWrite(lamp3,LOW);
    digitalWrite(lamp4,LOW);
    digitalWrite(lamp5,LOW);
    delay(500);
    if (buttonPress == 1) {
      start = 0;
    }
    
  }
}     //end of loop
